/**
 * tdesign v1.9.3
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

var _typeof = require('@babel/runtime/helpers/typeof');
var eq = require('./dep-49f0a63e.js');
var isArrayLike = require('./dep-a697b1b9.js');
var _isIndex = require('./dep-c65deed7.js');
var isObject = require('./dep-ef223206.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _typeof__default = /*#__PURE__*/_interopDefaultLegacy(_typeof);

/**
 * Checks if the given arguments are from an iteratee call.
 *
 * @private
 * @param {*} value The potential iteratee value argument.
 * @param {*} index The potential iteratee index or key argument.
 * @param {*} object The potential iteratee object argument.
 * @returns {boolean} Returns `true` if the arguments are from an iteratee call,
 *  else `false`.
 */
function isIterateeCall(value, index, object) {
  if (!isObject.isObject(object)) {
    return false;
  }
  var type = _typeof__default["default"](index);
  if (type == 'number' ? isArrayLike.isArrayLike(object) && _isIndex.isIndex(index, object.length) : type == 'string' && index in object) {
    return eq.eq(object[index], value);
  }
  return false;
}

exports.isIterateeCall = isIterateeCall;
//# sourceMappingURL=dep-324da301.js.map
