/**
 * tdesign v1.9.3
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var vue = require('vue');
var image_index = require('../image/index.js');
var empty_props = require('./props.js');
var config = require('../config.js');
var hooks_useClass = require('../hooks/useClass.js');
var hooks_tnode = require('../hooks/tnode.js');
require('../image/image.js');
require('@babel/runtime/helpers/slicedToArray');
require('@babel/runtime/helpers/defineProperty');
require('@vueuse/core');
require('tdesign-icons-vue-next');
require('../loading/index.js');
require('../loading/loading.js');
require('../loading/icon/gradient.js');
require('../_common/js/loading/circle-adapter.js');
require('../_common/js/utils/setStyle.js');
require('../_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../_chunks/dep-6b5052db.js');
require('../_chunks/dep-f11711eb.js');
require('../_chunks/dep-c3cb976c.js');
require('../_chunks/dep-2f809ed9.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-757b152c.js');
require('../_chunks/dep-5be9198d.js');
require('../_chunks/dep-ff4786c0.js');
require('../loading/icon/spinner.js');
require('../loading/props.js');
require('../shared/dom.js');
require('../_chunks/dep-88fe047a.js');
require('../_chunks/dep-ef223206.js');
require('../loading/plugin.js');
require('../_chunks/dep-b9642a56.js');
require('../_common/js/global-config/mobile/default-config.js');
require('../_common/js/global-config/mobile/locale/zh_CN.js');
require('../_chunks/dep-28b1e09d.js');
require('../_chunks/dep-57aa1aa0.js');
require('dayjs');
require('../_chunks/dep-85204fa0.js');
require('../_chunks/dep-f6b14f80.js');
require('../_chunks/dep-a8d60643.js');
require('../_chunks/dep-7c911ba3.js');
require('../_chunks/dep-49f0a63e.js');
require('../_chunks/dep-d950aa21.js');
require('../_chunks/dep-a697b1b9.js');
require('../_chunks/dep-4dfb9b9c.js');
require('../_chunks/dep-c65deed7.js');
require('../_chunks/dep-94eeec5a.js');
require('../_chunks/dep-060bf1cf.js');
require('../_chunks/dep-0e05e959.js');
require('../_chunks/dep-324da301.js');
require('../hooks/render-tnode.js');
require('../_chunks/dep-a7319409.js');
require('../_chunks/dep-afa9f3f2.js');
require('../_chunks/dep-ae809b86.js');
require('../_chunks/dep-2b08c0a6.js');
require('../_chunks/dep-288156c7.js');
require('../_chunks/dep-3d4c38f1.js');
require('../_chunks/dep-6df33aaf.js');
require('../_chunks/dep-675798b4.js');
require('../_chunks/dep-ccc9ad3d.js');
require('../_common/js/utils/general.js');
require('../_chunks/dep-21f18d3b.js');
require('../_chunks/dep-da6dc2cf.js');
require('../shared/component.js');
require('../image/props.js');

var prefix = config["default"].prefix;
var _Empty = vue.defineComponent({
  name: "".concat(prefix, "-empty"),
  props: empty_props["default"],
  setup: function setup(props) {
    var renderTNodeJSX = hooks_tnode.useTNodeJSX();
    var emptyClass = hooks_useClass.usePrefixClass("empty");
    return function () {
      var action = renderTNodeJSX("action");
      var description = renderTNodeJSX("description");
      var readerThumb = function readerThumb() {
        var image = renderTNodeJSX("image");
        if (image) {
          if (typeof props.image === "string") {
            return vue.withDirectives(vue.createVNode(image_index.Image, {
              "src": props.image
            }, null), [[vue.resolveDirective("if"), "typeof image === 'string'"]]);
          }
          return image;
        }
        var icon = renderTNodeJSX("icon");
        if (icon) {
          return vue.createVNode("div", {
            "class": "".concat(emptyClass.value, "__icon")
          }, [icon]);
        }
        return null;
      };
      return vue.createVNode("div", {
        "class": emptyClass.value
      }, [vue.createVNode("div", {
        "class": "".concat(emptyClass.value, "__thumb")
      }, [readerThumb()]), description && vue.createVNode("div", {
        "class": "".concat(emptyClass.value, "__description")
      }, [description]), action && vue.createVNode("div", {
        "class": "".concat(emptyClass.value, "__actions")
      }, [action])]);
    };
  }
});

exports["default"] = _Empty;
//# sourceMappingURL=empty.js.map
