/**
 * tdesign v1.9.3
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var vue = require('vue');
var shared_dom = require('../shared/dom.js');
var isFunction = require('../_chunks/dep-88fe047a.js');
require('../_chunks/dep-c3cb976c.js');
require('../_chunks/dep-2f809ed9.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-757b152c.js');
require('../_chunks/dep-5be9198d.js');
require('../_chunks/dep-ef223206.js');

var useTeleport = function useTeleport(attach, triggerNode) {
  var to = isFunction.isFunction(attach) ? vue.computed(attach) : vue.ref(attach);
  var innerTriggerNode = isFunction.isFunction(triggerNode) ? vue.computed(triggerNode) : vue.ref(triggerNode);
  var element = vue.ref();
  var getElement = function getElement() {
    element.value = shared_dom.getSSRAttach() || shared_dom.getAttach(to.value, innerTriggerNode.value);
  };
  vue.onMounted(function () {
    return getElement();
  });
  vue.watch([to, innerTriggerNode], function () {
    return getElement();
  });
  return element;
};

exports["default"] = useTeleport;
//# sourceMappingURL=useTeleport.js.map
