/**
 * tdesign v1.9.3
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var vue = require('vue');
var _common_js_loading_circleAdapter = require('../../_common/js/loading/circle-adapter.js');
var config = require('../../config.js');
var hooks_useClass = require('../../hooks/useClass.js');
require('@babel/runtime/helpers/defineProperty');
require('../../_common/js/utils/setStyle.js');
require('../../_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../../_chunks/dep-6b5052db.js');
require('../../_chunks/dep-f11711eb.js');
require('../../_chunks/dep-c3cb976c.js');
require('../../_chunks/dep-2f809ed9.js');
require('@babel/runtime/helpers/typeof');
require('../../_chunks/dep-757b152c.js');
require('../../_chunks/dep-5be9198d.js');
require('../../_chunks/dep-ff4786c0.js');
require('../../_chunks/dep-21f18d3b.js');
require('../../_chunks/dep-b9642a56.js');
require('../../_common/js/global-config/mobile/default-config.js');
require('../../_common/js/global-config/mobile/locale/zh_CN.js');
require('../../_chunks/dep-28b1e09d.js');
require('../../_chunks/dep-57aa1aa0.js');
require('dayjs');
require('../../_chunks/dep-85204fa0.js');
require('../../_chunks/dep-f6b14f80.js');
require('../../_chunks/dep-a8d60643.js');
require('../../_chunks/dep-7c911ba3.js');
require('../../_chunks/dep-88fe047a.js');
require('../../_chunks/dep-ef223206.js');
require('../../_chunks/dep-49f0a63e.js');
require('../../_chunks/dep-d950aa21.js');
require('../../_chunks/dep-a697b1b9.js');
require('../../_chunks/dep-4dfb9b9c.js');
require('../../_chunks/dep-c65deed7.js');
require('../../_chunks/dep-94eeec5a.js');
require('../../_chunks/dep-060bf1cf.js');
require('../../_chunks/dep-0e05e959.js');
require('../../_chunks/dep-324da301.js');
require('../../_chunks/dep-da6dc2cf.js');
require('../../_chunks/dep-ccc9ad3d.js');

var prefix = config["default"].prefix;
var TGradientIcon = vue.defineComponent({
  name: "".concat(prefix, "-gradient"),
  props: {
    style: Object
  },
  setup: function setup(props) {
    var classPrefix = hooks_useClass.usePrefixClass();
    var gradientClass = hooks_useClass.usePrefixClass("loading__gradient");
    var classes = [gradientClass.value, "".concat(classPrefix.value, "-icon-loading")];
    var circle = vue.ref();
    var updateColor = function updateColor() {
      var circleElem = circle.value;
      _common_js_loading_circleAdapter["default"](circleElem);
    };
    vue.onMounted(function () {
      vue.nextTick(function () {
        updateColor();
      });
    });
    vue.onUpdated(function () {
      updateColor();
    });
    return function () {
      return vue.createVNode("svg", {
        "style": props.style,
        "class": classes,
        "viewBox": "0 0 12 12",
        "version": "1.1",
        "width": "1em",
        "height": "1em",
        "xmlns": "http://www.w3.org/2000/svg"
      }, [vue.createVNode("foreignObject", {
        "x": "0",
        "y": "0",
        "width": "12",
        "height": "12"
      }, [vue.createVNode("div", {
        "ref": circle,
        "class": "".concat(gradientClass.value, "-conic")
      }, null)])]);
    };
  }
});

exports["default"] = TGradientIcon;
//# sourceMappingURL=gradient.js.map
