/**
 * tdesign v1.9.3
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var isArray = require('../_chunks/dep-757b152c.js');
var get = require('../_chunks/dep-7fa39e6f.js');
require('../_chunks/dep-0528a76d.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-2b08c0a6.js');
require('../_chunks/dep-2f809ed9.js');
require('../_chunks/dep-5be9198d.js');
require('../_chunks/dep-94eeec5a.js');
require('../_chunks/dep-7c911ba3.js');
require('../_chunks/dep-88fe047a.js');
require('../_chunks/dep-ef223206.js');
require('../_chunks/dep-49f0a63e.js');
require('../_chunks/dep-afa9f3f2.js');
require('../_chunks/dep-ae809b86.js');

var isMultipleArray = function isMultipleArray(arr) {
  return isArray.isArray(arr[0]);
};
var getPickerColumns = function getPickerColumns(columns) {
  return isMultipleArray(columns) ? columns : [columns];
};
var limitNumberInRange = function limitNumberInRange(num, min, max) {
  return Math.min(Math.max(num, min), max);
};
function findIndexOfEnabledOption(options, startIndex, keys) {
  var limitStartIndex = limitNumberInRange(startIndex, 0, options.length - 1);
  var forwardIndex = options.findIndex(function (opt, idx) {
    var _keys$disabled;
    return !get.get(opt, (_keys$disabled = keys === null || keys === void 0 ? void 0 : keys.disabled) !== null && _keys$disabled !== void 0 ? _keys$disabled : "disabled") && idx >= limitStartIndex;
  });
  if (forwardIndex !== -1) {
    return forwardIndex;
  }
  var backwardIndex = options.slice(0, limitStartIndex).reverse().findIndex(function (opt) {
    var _keys$disabled2;
    return !get.get(opt, (_keys$disabled2 = keys === null || keys === void 0 ? void 0 : keys.disabled) !== null && _keys$disabled2 !== void 0 ? _keys$disabled2 : "disabled");
  });
  if (backwardIndex !== -1) {
    return limitStartIndex - 1 - backwardIndex;
  }
  return 0;
}

exports.findIndexOfEnabledOption = findIndexOfEnabledOption;
exports.getPickerColumns = getPickerColumns;
exports.isMultipleArray = isMultipleArray;
exports.limitNumberInRange = limitNumberInRange;
//# sourceMappingURL=utils.js.map
