/**
 * tdesign v1.9.3
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var vue = require('vue');
var tdesignIconsVueNext = require('tdesign-icons-vue-next');
var core = require('@vueuse/core');
var config = require('../config.js');
var shared_dom = require('../shared/dom.js');
var search_props = require('./props.js');
var hooks_useVModel = require('../hooks/useVModel.js');
var hooks_useClass = require('../hooks/useClass.js');
var hooks_tnode = require('../hooks/tnode.js');
var hooks_useLengthLimit = require('../hooks/useLengthLimit.js');
var _common_js_common = require('../_common/js/common.js');
var cell_cell = require('../cell/cell.js');
require('../_chunks/dep-88fe047a.js');
require('../_chunks/dep-2f809ed9.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-ef223206.js');
require('../_chunks/dep-c3cb976c.js');
require('../_chunks/dep-757b152c.js');
require('../_chunks/dep-5be9198d.js');
require('../_chunks/dep-6df33aaf.js');
require('../_chunks/dep-3d4c38f1.js');
require('../_chunks/dep-afa9f3f2.js');
require('../_chunks/dep-ae809b86.js');
require('../_chunks/dep-2b08c0a6.js');
require('../_chunks/dep-21f18d3b.js');
require('../_chunks/dep-b9642a56.js');
require('../_common/js/global-config/mobile/default-config.js');
require('../_common/js/global-config/mobile/locale/zh_CN.js');
require('../_chunks/dep-28b1e09d.js');
require('../_chunks/dep-57aa1aa0.js');
require('dayjs');
require('../_chunks/dep-85204fa0.js');
require('../_chunks/dep-f6b14f80.js');
require('../_chunks/dep-a8d60643.js');
require('../_chunks/dep-7c911ba3.js');
require('../_chunks/dep-49f0a63e.js');
require('../_chunks/dep-d950aa21.js');
require('../_chunks/dep-a697b1b9.js');
require('../_chunks/dep-4dfb9b9c.js');
require('../_chunks/dep-c65deed7.js');
require('../_chunks/dep-94eeec5a.js');
require('../_chunks/dep-060bf1cf.js');
require('../_chunks/dep-0e05e959.js');
require('../_chunks/dep-324da301.js');
require('../_chunks/dep-da6dc2cf.js');
require('../_chunks/dep-ccc9ad3d.js');
require('../hooks/render-tnode.js');
require('../_chunks/dep-a7319409.js');
require('../_chunks/dep-288156c7.js');
require('../_chunks/dep-675798b4.js');
require('../_common/js/utils/general.js');
require('../_common/js/log/log.js');
require('../_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../_chunks/dep-6b5052db.js');
require('../_chunks/dep-f11711eb.js');
require('../_chunks/dep-ff4786c0.js');
require('../cell/props.js');
require('../form/hooks.js');
require('../_chunks/dep-d5bc9590.js');
require('../shared/hover.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);
var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);

var prefix = config["default"].prefix;
var _Search = vue.defineComponent({
  name: "".concat(prefix, "-search"),
  props: search_props["default"],
  setup: function setup(props, context) {
    var renderTNodeJSX = hooks_tnode.useTNodeJSX();
    var classPrefix = hooks_useClass.usePrefixClass();
    var searchClass = hooks_useClass.usePrefixClass("search");
    var isShowResultList = vue.ref(false);
    var inputRef = vue.ref();
    var _useFocus = core.useFocus(inputRef, {
        initialValue: props.focus
      }),
      focused = _useFocus.focused;
    var _toRefs = vue.toRefs(props),
      value = _toRefs.value,
      modelValue = _toRefs.modelValue;
    var _useVModel = hooks_useVModel["default"](value, modelValue, props.defaultValue, props.onChange),
      _useVModel2 = _slicedToArray__default["default"](_useVModel, 2),
      searchValue = _useVModel2[0],
      setSearchValue = _useVModel2[1];
    var boxClasses = vue.computed(function () {
      return ["".concat(searchClass.value, "__input-box"), "".concat(searchClass.value, "__input-box--").concat(props.shape), _defineProperty__default["default"]({}, "".concat(classPrefix.value, "-is-focused"), focused.value)];
    });
    var inputClasses = vue.computed(function () {
      return ["".concat(classPrefix.value, "-input__keyword"), _defineProperty__default["default"]({}, "".concat(searchClass.value, "--center"), props.center)];
    });
    var limitParams = vue.computed(function () {
      return {
        value: [void 0, null].includes(searchValue.value) ? void 0 : String(searchValue.value),
        maxlength: Number(props.maxlength),
        maxcharacter: props.maxcharacter,
        allowInputOverMax: false
      };
    });
    var _useLengthLimit = hooks_useLengthLimit["default"](limitParams),
      getValueByLimitNumber = _useLengthLimit.getValueByLimitNumber;
    var setInputValue = function setInputValue(v) {
      var input = inputRef.value;
      var sV = String(v);
      if (!input) {
        return;
      }
      if (input.value !== sV) {
        input.value = sV;
      }
    };
    var inputValueChangeHandle = function inputValueChangeHandle(e) {
      var value2 = e.target.value;
      setSearchValue(getValueByLimitNumber(value2));
      vue.nextTick(function () {
        return setInputValue(searchValue.value);
      });
    };
    var handleInput = function handleInput(e) {
      isShowResultList.value = true;
      if (e instanceof InputEvent) {
        var checkInputType = e.inputType && e.inputType === "insertCompositionText";
        if (e.isComposing || checkInputType) return;
      }
      inputValueChangeHandle(e);
    };
    var handleClear = function handleClear(e) {
      var _props$onClear;
      setSearchValue("");
      focused.value = true;
      (_props$onClear = props.onClear) === null || _props$onClear === void 0 || _props$onClear.call(props, {
        e: e
      });
    };
    var handleFocus = function handleFocus(e) {
      var _props$onFocus;
      (_props$onFocus = props.onFocus) === null || _props$onFocus === void 0 || _props$onFocus.call(props, {
        value: searchValue.value,
        e: e
      });
    };
    var handleBlur = function handleBlur(e) {
      var _props$onBlur;
      (_props$onBlur = props.onBlur) === null || _props$onBlur === void 0 || _props$onBlur.call(props, {
        value: searchValue.value,
        e: e
      });
    };
    var handleCompositionend = function handleCompositionend(e) {
      inputValueChangeHandle(e);
    };
    var handleAction = function handleAction(e) {
      var _props$onActionClick;
      (_props$onActionClick = props.onActionClick) === null || _props$onActionClick === void 0 || _props$onActionClick.call(props, {
        e: e
      });
    };
    var handleSearch = function handleSearch(e) {
      if (_common_js_common.ENTER_REG.test(e.code) || _common_js_common.ENTER_REG.test(e.key)) {
        var _inputRef$value, _props$onSubmit;
        shared_dom.preventDefault(e, false);
        (_inputRef$value = inputRef.value) === null || _inputRef$value === void 0 || _inputRef$value.blur();
        (_props$onSubmit = props.onSubmit) === null || _props$onSubmit === void 0 || _props$onSubmit.call(props, {
          value: searchValue.value,
          e: e
        });
      }
    };
    return function () {
      var readerLeftIcon = function readerLeftIcon() {
        var leftIcon = renderTNodeJSX("leftIcon");
        if (leftIcon === "search") {
          return vue.createVNode(tdesignIconsVueNext.SearchIcon, {
            "size": "24px"
          }, null);
        }
        return renderTNodeJSX("leftIcon");
      };
      var readerClear = function readerClear() {
        if (props.clearable && searchValue.value && (props.clearTrigger === "always" || props.clearTrigger === "focus" && focused.value)) {
          return vue.createVNode("div", {
            "class": "".concat(searchClass.value, "__clear"),
            "onClick": handleClear
          }, [vue.createVNode(tdesignIconsVueNext.CloseCircleFilledIcon, {
            "size": "24"
          }, null)]);
        }
        return null;
      };
      var readerAction = function readerAction() {
        var action = renderTNodeJSX("action");
        if (action) {
          return vue.createVNode("div", {
            "class": "".concat(searchClass.value, "__search-action ").concat(classPrefix.value, "-class-action"),
            "onClick": handleAction
          }, [action]);
        }
        return null;
      };
      var onSelectResultItem = function onSelectResultItem(params) {
        isShowResultList.value = false;
        setSearchValue(params.item);
      };
      var highlightSearchValue = function highlightSearchValue(item, searchValue2) {
        var parts = item.split(new RegExp("(".concat(searchValue2, ")"), "gi"));
        return parts.map(function (part, index) {
          return part.toLowerCase() === searchValue2.toLowerCase() ? vue.createVNode("span", {
            "key": index,
            "class": "".concat(searchClass.value, "__result-item--highLight")
          }, [part]) : part;
        });
      };
      var listNodes = function listNodes(params) {
        return vue.h(cell_cell["default"], {
          key: params.index,
          class: "".concat(searchClass.value, "__result-item"),
          onClick: function onClick() {
            return onSelectResultItem({
              item: params.item
            });
          }
        }, {
          title: function title() {
            return highlightSearchValue(params.item, searchValue.value);
          }
        });
      };
      var extraProps = {
        enterkeyhint: "search"
      };
      return vue.createVNode("div", null, [vue.createVNode("div", {
        "class": "".concat(searchClass.value)
      }, [vue.createVNode("div", {
        "class": boxClasses.value
      }, [readerLeftIcon(), vue.createVNode("input", vue.mergeProps({
        "ref": inputRef,
        "value": searchValue.value,
        "type": "search",
        "class": inputClasses.value,
        "autofocus": props.focus,
        "placeholder": props.placeholder,
        "readonly": props.readonly,
        "disabled": props.disabled,
        "onKeypress": handleSearch,
        "onFocus": handleFocus,
        "onBlur": handleBlur,
        "onInput": handleInput,
        "onCompositionend": handleCompositionend
      }, extraProps), null), readerClear()]), readerAction()]), isShowResultList.value && vue.createVNode("div", {
        "class": "".concat(searchClass.value, "__result-list")
      }, [props.resultList.map(function (item, index) {
        return listNodes({
          item: item,
          index: index
        });
      })])]);
    };
  }
});

exports["default"] = _Search;
//# sourceMappingURL=search.js.map
