/**
 * tdesign v1.9.3
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _toConsumableArray = require('@babel/runtime/helpers/toConsumableArray');
var core = require('@vueuse/core');
var shared_util = require('../util.js');
var isArray = require('../../_chunks/dep-757b152c.js');
require('@babel/runtime/helpers/slicedToArray');
require('../../hooks/useClass.js');
require('vue');
require('../../_chunks/dep-21f18d3b.js');
require('@babel/runtime/helpers/defineProperty');
require('../../_chunks/dep-b9642a56.js');
require('../../_common/js/global-config/mobile/default-config.js');
require('../../_common/js/global-config/mobile/locale/zh_CN.js');
require('../../_chunks/dep-28b1e09d.js');
require('@babel/runtime/helpers/typeof');
require('../../_chunks/dep-57aa1aa0.js');
require('dayjs');
require('../../_chunks/dep-85204fa0.js');
require('../../_chunks/dep-f6b14f80.js');
require('../../_chunks/dep-a8d60643.js');
require('../../_chunks/dep-7c911ba3.js');
require('../../_chunks/dep-88fe047a.js');
require('../../_chunks/dep-2f809ed9.js');
require('../../_chunks/dep-ef223206.js');
require('../../_chunks/dep-49f0a63e.js');
require('../../_chunks/dep-d950aa21.js');
require('../../_chunks/dep-5be9198d.js');
require('../../_chunks/dep-a697b1b9.js');
require('../../_chunks/dep-4dfb9b9c.js');
require('../../_chunks/dep-c65deed7.js');
require('../../_chunks/dep-94eeec5a.js');
require('../../_chunks/dep-060bf1cf.js');
require('../../_chunks/dep-0e05e959.js');
require('../../_chunks/dep-324da301.js');
require('../../_chunks/dep-da6dc2cf.js');
require('../../_chunks/dep-ccc9ad3d.js');
require('../../_chunks/dep-c3cb976c.js');
require('../../_chunks/dep-ff4786c0.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _toConsumableArray__default = /*#__PURE__*/_interopDefaultLegacy(_toConsumableArray);

function useClickAway(target, fn) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  if (!shared_util.isBrowser) return;
  var _options$eventName = options.eventName,
    eventName = _options$eventName === void 0 ? "touchstart" : _options$eventName,
    _options$capture = options.capture,
    capture = _options$capture === void 0 ? true : _options$capture,
    _options$ignore = options.ignore,
    ignore = _options$ignore === void 0 ? [] : _options$ignore,
    _options$detectIframe = options.detectIframe,
    detectIframe = _options$detectIframe === void 0 ? false : _options$detectIframe;
  var listenerOptions = {
    passive: true,
    capture: capture
  };
  var checkElInEvtTarget = function checkElInEvtTarget(el, event) {
    return el && (event.target === el || event.composedPath().includes(el));
  };
  var shouldIgnore = function shouldIgnore(event) {
    return ignore.some(function (ignoreTarget) {
      return checkElInEvtTarget(core.unrefElement(ignoreTarget), event);
    });
  };
  var eventHandler = function eventHandler(event) {
    var targets = isArray.isArray(target) ? _toConsumableArray__default["default"](target) : [target];
    var shouldTrigger = targets.every(function (targetItem) {
      return !checkElInEvtTarget(core.unrefElement(targetItem), event);
    });
    if (!shouldTrigger) return;
    shouldTrigger = !shouldIgnore(event);
    if (!shouldTrigger) return;
    fn(event);
  };
  var cleanup = [core.useEventListener(window, eventName, eventHandler, listenerOptions)];
  if (detectIframe) {
    cleanup.push(core.useEventListener(window, "blur", function (event) {
      setTimeout(function () {
        var targets = isArray.isArray(target) ? _toConsumableArray__default["default"](target) : [target];
        if (targets.every(function (targetItem) {
          var _window$document$acti;
          var el = core.unrefElement(targetItem);
          return ((_window$document$acti = window.document.activeElement) === null || _window$document$acti === void 0 ? void 0 : _window$document$acti.tagName) === "IFRAME" && !(el !== null && el !== void 0 && el.contains(window.document.activeElement));
        })) {
          fn(event);
        }
      }, 0);
    }));
  }
  return function () {
    return cleanup.forEach(function (clean) {
      return clean();
    });
  };
}

exports.useClickAway = useClickAway;
//# sourceMappingURL=index.js.map
