/**
 * tdesign v1.9.3
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var vue = require('vue');
var shared_util = require('../util.js');
require('@babel/runtime/helpers/slicedToArray');
require('../../hooks/useClass.js');
require('../../_chunks/dep-21f18d3b.js');
require('@babel/runtime/helpers/defineProperty');
require('../../_chunks/dep-b9642a56.js');
require('../../_common/js/global-config/mobile/default-config.js');
require('../../_common/js/global-config/mobile/locale/zh_CN.js');
require('../../_chunks/dep-28b1e09d.js');
require('@babel/runtime/helpers/typeof');
require('../../_chunks/dep-57aa1aa0.js');
require('dayjs');
require('../../_chunks/dep-85204fa0.js');
require('../../_chunks/dep-f6b14f80.js');
require('../../_chunks/dep-a8d60643.js');
require('../../_chunks/dep-7c911ba3.js');
require('../../_chunks/dep-88fe047a.js');
require('../../_chunks/dep-2f809ed9.js');
require('../../_chunks/dep-ef223206.js');
require('../../_chunks/dep-49f0a63e.js');
require('../../_chunks/dep-d950aa21.js');
require('../../_chunks/dep-5be9198d.js');
require('../../_chunks/dep-a697b1b9.js');
require('../../_chunks/dep-4dfb9b9c.js');
require('../../_chunks/dep-757b152c.js');
require('../../_chunks/dep-c65deed7.js');
require('../../_chunks/dep-94eeec5a.js');
require('../../_chunks/dep-060bf1cf.js');
require('../../_chunks/dep-0e05e959.js');
require('../../_chunks/dep-324da301.js');
require('../../_chunks/dep-da6dc2cf.js');
require('../../_chunks/dep-ccc9ad3d.js');
require('../../_chunks/dep-c3cb976c.js');
require('../../_chunks/dep-ff4786c0.js');

var overflowScrollReg = /scroll|auto/i;
var defaultRoot = shared_util.isBrowser ? window : void 0;
function isElement(node) {
  var ELEMENT_NODE_TYPE = 1;
  return node.tagName !== "HTML" && node.tagName !== "BODY" && node.nodeType === ELEMENT_NODE_TYPE;
}
function getScrollParent(el) {
  var root = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultRoot;
  var node = el;
  while (node && node !== root && isElement(node)) {
    var _window$getComputedSt = window.getComputedStyle(node),
      overflowY = _window$getComputedSt.overflowY;
    if (overflowScrollReg.test(overflowY)) {
      return node;
    }
    node = node.parentNode;
  }
  return root;
}
function useScrollParent(el) {
  var root = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultRoot;
  var scrollParent = vue.ref();
  vue.onMounted(function () {
    if (el.value) {
      scrollParent.value = getScrollParent(el.value, root);
    }
  });
  return scrollParent;
}

exports.getScrollParent = getScrollParent;
exports.useScrollParent = useScrollParent;
//# sourceMappingURL=index.js.map
