/**
 * tdesign v1.9.3
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var hooks_useClass = require('../hooks/useClass.js');
var isNumber = require('../_chunks/dep-ff4786c0.js');
require('vue');
require('../_chunks/dep-21f18d3b.js');
require('@babel/runtime/helpers/defineProperty');
require('../_chunks/dep-b9642a56.js');
require('../_common/js/global-config/mobile/default-config.js');
require('../_common/js/global-config/mobile/locale/zh_CN.js');
require('../_chunks/dep-28b1e09d.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-57aa1aa0.js');
require('dayjs');
require('../_chunks/dep-85204fa0.js');
require('../_chunks/dep-f6b14f80.js');
require('../_chunks/dep-a8d60643.js');
require('../_chunks/dep-7c911ba3.js');
require('../_chunks/dep-88fe047a.js');
require('../_chunks/dep-2f809ed9.js');
require('../_chunks/dep-ef223206.js');
require('../_chunks/dep-49f0a63e.js');
require('../_chunks/dep-d950aa21.js');
require('../_chunks/dep-5be9198d.js');
require('../_chunks/dep-a697b1b9.js');
require('../_chunks/dep-4dfb9b9c.js');
require('../_chunks/dep-757b152c.js');
require('../_chunks/dep-c65deed7.js');
require('../_chunks/dep-94eeec5a.js');
require('../_chunks/dep-060bf1cf.js');
require('../_chunks/dep-0e05e959.js');
require('../_chunks/dep-324da301.js');
require('../_chunks/dep-da6dc2cf.js');
require('../_chunks/dep-ccc9ad3d.js');
require('../_chunks/dep-c3cb976c.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);

function toCamel(str) {
  return str.replace(/^\S/, function (m) {
    return m.toUpperCase();
  });
}
var isBrowser = typeof window !== "undefined";
var sleep = function sleep(ms) {
  return new Promise(function (resolve) {
    return setTimeout(resolve, ms);
  });
};
var uniqueFactory = function uniqueFactory(compName) {
  var number = 0;
  var prefixClass = hooks_useClass.usePrefixClass();
  return function () {
    return "".concat(prefixClass.value, "-").concat(compName, "_").concat(number++);
  };
};
var convertUnit = function convertUnit(val) {
  if (val == null) return 0;
  return isNumber.isNumber(val) ? "".concat(val, "px") : val;
};
var reconvertUnit = function reconvertUnit(val) {
  if (val == null) return 0;
  return isNumber.isNumber(val) ? Number(val) : Number(val.slice(0, -2));
};
var formatNumber = function formatNumber(value) {
  var allowDecimal = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  var allowNegative = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
  if (allowDecimal) {
    var index = value.indexOf(".");
    if (index !== -1) {
      value = "".concat(value.slice(0, index + 1)).concat(value.slice(index).replace(/\./g, ""));
    }
  } else {
    var _value$split = value.split("."),
      _value$split2 = _slicedToArray__default["default"](_value$split, 1),
      _value$split2$ = _value$split2[0],
      splitValue = _value$split2$ === void 0 ? "" : _value$split2$;
    value = splitValue;
  }
  if (allowNegative) {
    var _index = value.indexOf("-");
    if (_index !== -1) {
      value = "".concat(value.slice(0, _index + 1)).concat(value.slice(_index).replace(/-/g, ""));
    }
  } else {
    value = value.replace(/-/g, "");
  }
  return value.replace(/[^\d.-]/g, "");
};

exports.convertUnit = convertUnit;
exports.formatNumber = formatNumber;
exports.isBrowser = isBrowser;
exports.reconvertUnit = reconvertUnit;
exports.sleep = sleep;
exports.toCamel = toCamel;
exports.uniqueFactory = uniqueFactory;
//# sourceMappingURL=util.js.map
