/**
 * tdesign v1.9.3
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var vue = require('vue');
var sideBar_sideBarItemProps = require('./side-bar-item-props.js');
var badge_index = require('../badge/index.js');
var hooks_tnode = require('../hooks/tnode.js');
var config = require('../config.js');
var hooks_useClass = require('../hooks/useClass.js');
require('../badge/badge.js');
require('@babel/runtime/helpers/slicedToArray');
require('../badge/props.js');
require('../_chunks/dep-c3cb976c.js');
require('../_chunks/dep-2f809ed9.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-757b152c.js');
require('../_chunks/dep-5be9198d.js');
require('../_chunks/dep-ff4786c0.js');
require('../shared/component.js');
require('../_chunks/dep-21f18d3b.js');
require('../_chunks/dep-b9642a56.js');
require('../_common/js/global-config/mobile/default-config.js');
require('../_common/js/global-config/mobile/locale/zh_CN.js');
require('../_chunks/dep-28b1e09d.js');
require('../_chunks/dep-57aa1aa0.js');
require('dayjs');
require('../_chunks/dep-85204fa0.js');
require('../_chunks/dep-f6b14f80.js');
require('../_chunks/dep-a8d60643.js');
require('../_chunks/dep-7c911ba3.js');
require('../_chunks/dep-88fe047a.js');
require('../_chunks/dep-ef223206.js');
require('../_chunks/dep-49f0a63e.js');
require('../_chunks/dep-d950aa21.js');
require('../_chunks/dep-a697b1b9.js');
require('../_chunks/dep-4dfb9b9c.js');
require('../_chunks/dep-c65deed7.js');
require('../_chunks/dep-94eeec5a.js');
require('../_chunks/dep-060bf1cf.js');
require('../_chunks/dep-0e05e959.js');
require('../_chunks/dep-324da301.js');
require('../_chunks/dep-da6dc2cf.js');
require('../_chunks/dep-ccc9ad3d.js');
require('../hooks/render-tnode.js');
require('../_chunks/dep-a7319409.js');
require('../_chunks/dep-afa9f3f2.js');
require('../_chunks/dep-ae809b86.js');
require('../_chunks/dep-2b08c0a6.js');
require('../_chunks/dep-288156c7.js');
require('../_chunks/dep-3d4c38f1.js');
require('../_chunks/dep-6df33aaf.js');
require('../_chunks/dep-675798b4.js');
require('../_common/js/utils/general.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

var prefix = config["default"].prefix;
var _SideBarItem = vue.defineComponent({
  name: "".concat(prefix, "-side-bar-item"),
  props: sideBar_sideBarItemProps["default"],
  setup: function setup(props2) {
    var sideBarItemClass = hooks_useClass.usePrefixClass("side-bar-item");
    var renderTNodeJSX = hooks_tnode.useTNodeJSX();
    var internalInstance = vue.getCurrentInstance();
    var proxy = internalInstance.proxy;
    var sideBarProvide = vue.inject("sideBarProvide", void 0);
    sideBarProvide.relation(proxy);
    var isActive = vue.computed(function () {
      return proxy.value === sideBarProvide.currentValue.value;
    });
    var rootClassName = vue.computed(function () {
      return [sideBarItemClass.value, _defineProperty__default["default"]({}, "".concat(sideBarItemClass.value, "--active"), isActive.value), _defineProperty__default["default"]({}, "".concat(sideBarItemClass.value, "--disabled"), props2.disabled)];
    });
    var onClick = function onClick(e) {
      if (props2.disabled) return;
      sideBarProvide.onClickItem(proxy.value, props2.label);
    };
    vue.onUnmounted(function () {
      sideBarProvide.removeRelation(proxy);
    });
    return function () {
      var renderIconNode = function renderIconNode() {
        var iconNode = renderTNodeJSX("icon");
        if (!iconNode) {
          return null;
        }
        return vue.createVNode("div", {
          "class": "".concat(sideBarItemClass.value, "__icon")
        }, [iconNode]);
      };
      return vue.createVNode("div", {
        "class": rootClassName.value,
        "onClick": onClick
      }, [isActive.value && vue.createVNode("div", null, [vue.createVNode("div", {
        "class": "".concat(sideBarItemClass.value, "__line")
      }, null), vue.createVNode("div", {
        "class": "".concat(sideBarItemClass.value, "__prefix")
      }, null), vue.createVNode("div", {
        "class": "".concat(sideBarItemClass.value, "__suffix")
      }, null)]), renderIconNode(), props2.badgeProps ? vue.createVNode(badge_index.Badge, vue.mergeProps(props2.badgeProps, {
        "content": props2.label
      }), null) : vue.createVNode("div", null, [props2.label])]);
    };
  }
});

exports["default"] = _SideBarItem;
//# sourceMappingURL=side-bar-item.js.map
