/**
 * tdesign v1.9.3
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var vue = require('vue');
var loading_index = require('../loading/index.js');
var hooks_useToggle = require('../hooks/useToggle.js');
var config = require('../config.js');
var switch_props = require('./props.js');
var form_hooks = require('../form/hooks.js');
var hooks_useVModel = require('../hooks/useVModel.js');
var hooks_useClass = require('../hooks/useClass.js');
var isArray = require('../_chunks/dep-757b152c.js');
var isString = require('../_chunks/dep-c3cb976c.js');
var isFunction = require('../_chunks/dep-88fe047a.js');
require('../loading/loading.js');
require('../loading/icon/gradient.js');
require('../_common/js/loading/circle-adapter.js');
require('../_common/js/utils/setStyle.js');
require('../_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../_chunks/dep-6b5052db.js');
require('../_chunks/dep-f11711eb.js');
require('../_chunks/dep-ff4786c0.js');
require('../_chunks/dep-2f809ed9.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-5be9198d.js');
require('../loading/icon/spinner.js');
require('../loading/props.js');
require('../hooks/tnode.js');
require('../hooks/render-tnode.js');
require('../_chunks/dep-ef223206.js');
require('../_chunks/dep-a7319409.js');
require('../_chunks/dep-afa9f3f2.js');
require('../_chunks/dep-ae809b86.js');
require('../_chunks/dep-2b08c0a6.js');
require('../_chunks/dep-288156c7.js');
require('../_chunks/dep-3d4c38f1.js');
require('../_chunks/dep-6df33aaf.js');
require('../_chunks/dep-675798b4.js');
require('../_chunks/dep-ccc9ad3d.js');
require('../_chunks/dep-d950aa21.js');
require('../_chunks/dep-a697b1b9.js');
require('../_chunks/dep-4dfb9b9c.js');
require('../_chunks/dep-7c911ba3.js');
require('../_common/js/utils/general.js');
require('../shared/dom.js');
require('../loading/plugin.js');
require('../_chunks/dep-b9642a56.js');
require('../_common/js/global-config/mobile/default-config.js');
require('../_common/js/global-config/mobile/locale/zh_CN.js');
require('../_chunks/dep-28b1e09d.js');
require('../_chunks/dep-57aa1aa0.js');
require('dayjs');
require('../_chunks/dep-85204fa0.js');
require('../_chunks/dep-f6b14f80.js');
require('../_chunks/dep-a8d60643.js');
require('../_chunks/dep-49f0a63e.js');
require('../_chunks/dep-c65deed7.js');
require('../_chunks/dep-94eeec5a.js');
require('../_chunks/dep-060bf1cf.js');
require('../_chunks/dep-0e05e959.js');
require('../_chunks/dep-324da301.js');
require('../_chunks/dep-21f18d3b.js');
require('../_chunks/dep-da6dc2cf.js');
require('../shared/component.js');
require('../_chunks/dep-d5bc9590.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);
var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);

var prefix = config["default"].prefix;
var _Switch = vue.defineComponent({
  name: "".concat(prefix, "-switch"),
  props: switch_props["default"],
  setup: function setup(props2, context) {
    var switchClass = hooks_useClass.usePrefixClass("switch");
    var disabled = form_hooks.useFormDisabled();
    var switchValues = props2.customValue || [true, false];
    var _toRefs = vue.toRefs(props2),
      value = _toRefs.value,
      modelValue = _toRefs.modelValue;
    var _useVModel = hooks_useVModel["default"](value, modelValue, props2.defaultValue, props2.onChange),
      _useVModel2 = _slicedToArray__default["default"](_useVModel, 2),
      innerValue = _useVModel2[0],
      setInnerValue = _useVModel2[1];
    var _useToggle = hooks_useToggle["default"](switchValues, innerValue.value),
      state = _useToggle.state,
      toggle = _useToggle.toggle;
    var checked = vue.computed(function () {
      return innerValue.value === switchValues[0];
    });
    var switchClasses = vue.computed(function () {
      return ["".concat(switchClass.value), "".concat(switchClass.value, "--").concat(props2.size), _defineProperty__default["default"](_defineProperty__default["default"]({}, "".concat(switchClass.value, "--checked"), checked.value), "".concat(switchClass.value, "--disabled"), disabled.value || props2.loading)];
    });
    var dotClasses = vue.computed(function () {
      var _props2$label, _props2$icon;
      return ["".concat(switchClass.value, "__dot"), "".concat(switchClass.value, "__dot--").concat(props2.size), _defineProperty__default["default"](_defineProperty__default["default"]({}, "".concat(switchClass.value, "__dot--checked"), checked.value), "".concat(switchClass.value, "__dot--plain"), ((_props2$label = props2.label) === null || _props2$label === void 0 ? void 0 : _props2$label.length) !== 2 && ((_props2$icon = props2.icon) === null || _props2$icon === void 0 ? void 0 : _props2$icon.length) !== 2 && !props2.loading)];
    });
    var labelClasses = vue.computed(function () {
      return ["".concat(switchClass.value, "__label"), "".concat(switchClass.value, "__label--").concat(props2.size), _defineProperty__default["default"]({}, "".concat(switchClass.value, "__label--checked"), checked.value)];
    });
    var iconContent = vue.computed(function () {
      return props2.icon[checked.value ? 0 : 1];
    });
    function handleToggle(event) {
      event.preventDefault();
      if (disabled.value || props2.loading) {
        return;
      }
      if (state.value === innerValue.value) {
        toggle();
      }
      setInnerValue(state.value);
    }
    var renderContent = function renderContent() {
      if (props2.loading) {
        return vue.createVNode(loading_index.Loading, {
          "inherit-color": true,
          "size": "16.25px"
        }, null);
      }
      if (isArray.isArray(props2.label) && props2.label.length === 2) {
        var label = checked.value ? props2.label[0] : props2.label[1];
        if (isString.isString(label)) {
          return label;
        }
        if (isFunction.isFunction(label)) {
          return label(vue.h);
        }
      }
      if (isFunction.isFunction(props2.label)) {
        return props2.label(vue.h, {
          value: innerValue.value
        });
      }
      if (context.slots.label) {
        return context.slots.label({
          value: innerValue.value
        });
      }
      return iconContent.value;
    };
    return function () {
      return vue.createVNode("div", {
        "class": switchClasses.value,
        "onClick": handleToggle
      }, [vue.createVNode("div", {
        "class": dotClasses.value
      }, [vue.createVNode("div", {
        "class": labelClasses.value
      }, [renderContent()])])]);
    };
  }
});

exports["default"] = _Switch;
//# sourceMappingURL=switch.js.map
