/**
 * tdesign v1.9.3
 * (c) 2025 TDesign Group
 * @license MIT
 */

import { _ as _defineProperty } from '../_chunks/dep-900db0e1.mjs';
import { ref, createApp, nextTick } from 'vue';
import ActionSheetVue from './action-sheet.mjs';
import '../shared/index.mjs';
import './style/css.mjs';
import './type.mjs';
import { isBrowser } from '../shared/util.mjs';
import '../_chunks/dep-4915223e.mjs';
import '../_chunks/dep-26b97ced.mjs';
import '../_chunks/dep-a953013f.mjs';
import './action-sheet-grid.mjs';
import '../grid/index.mjs';
import '../grid/grid.mjs';
import '../config.mjs';
import '../grid/props.mjs';
import '../hooks/useClass.mjs';
import '../config-provider/useConfig.mjs';
import 'lodash-es';
import '../config-provider/context.mjs';
import '../_common/js/global-config/mobile/default-config.mjs';
import '../_common/js/global-config/mobile/locale/zh_CN.mjs';
import '../_chunks/dep-bca0f578.mjs';
import '../_chunks/dep-6b2b02fd.mjs';
import '../_chunks/dep-c6f44a15.mjs';
import '../_chunks/dep-c984d53e.mjs';
import '../config-provider/type.mjs';
import '../grid/grid-item.mjs';
import '../grid/grid-item-props.mjs';
import '../hooks/tnode.mjs';
import '../hooks/render-tnode.mjs';
import '../_common/js/utils/general.mjs';
import '../image/index.mjs';
import '../image/image.mjs';
import '@vueuse/core';
import 'tdesign-icons-vue-next';
import '../loading/index.mjs';
import '../loading/loading.mjs';
import '../loading/icon/gradient.mjs';
import '../_common/js/loading/circle-adapter.mjs';
import '../_common/js/utils/setStyle.mjs';
import '../_common/js/utils/helper.mjs';
import '../_chunks/dep-fb4113ef.mjs';
import '../_chunks/dep-da32ae58.mjs';
import '../loading/icon/spinner.mjs';
import '../loading/props.mjs';
import '../shared/dom.mjs';
import '../loading/type.mjs';
import '../loading/plugin.mjs';
import '../shared/component.mjs';
import '../image/props.mjs';
import '../image/type.mjs';
import '../shared/functions.mjs';
import '../shared/render.mjs';
import '../shared/render-tnode.mjs';
import '../shared/useCountDown/index.mjs';
import '../_chunks/dep-99e43b7b.mjs';
import '../shared/useCountDown/utils.mjs';
import '../shared/useTouch/index.mjs';
import '../shared/useScrollParent/index.mjs';
import '../shared/useTest/index.mjs';
import '../shared/useClickAway/index.mjs';
import '../shared/hover.mjs';
import '../badge/index.mjs';
import '../badge/badge.mjs';
import '../badge/props.mjs';
import '../badge/type.mjs';
import '../grid/type.mjs';
import '../swiper/index.mjs';
import '../swiper/swiper.mjs';
import '../swipe-cell/useSwipe.mjs';
import '../swiper/props.mjs';
import '../hooks/useVModel.mjs';
import '../swiper/swiper-item.mjs';
import '../swiper/type.mjs';
import './action-sheet-list.mjs';
import '../button/index.mjs';
import '../button/button.mjs';
import '../button/props.mjs';
import '../form/hooks.mjs';
import '../button/type.mjs';
import '../popup/index.mjs';
import '../popup/popup.mjs';
import '../popup/props.mjs';
import '../overlay/index.mjs';
import '../overlay/overlay.mjs';
import '../overlay/props.mjs';
import '../hooks/useLockScroll.mjs';
import '../_util/useTouch.mjs';
import '../_util/getScrollParent.mjs';
import '../hooks/useTeleport.mjs';
import '../popup/type.mjs';
import './props.mjs';

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var instance = null;
var app;
function create(props) {
  if (!isBrowser) return;
  var root = document.createElement("div");
  document.body.appendChild(root);
  var visible = ref(false);
  var propsObject = _objectSpread({
    visible: visible
  }, props);
  if (instance) {
    instance.clear();
  }
  instance = ActionSheetVue;
  instance.clear = function (trigger) {
    app.unmount();
    root.remove();
    if (propsObject.onClose && trigger && trigger.trigger !== "overlay") {
      propsObject.onClose(trigger);
    }
    instance = null;
  };
  app = createApp(instance, _objectSpread({}, propsObject));
  app.mount(root);
  nextTick(function () {
    visible.value = true;
  });
  return instance;
}
function ActionSheet(props) {
  create(props);
}
ActionSheet.close = function (trigger) {
  if (instance) {
    instance.clear(trigger);
  }
};
ActionSheet.show = function (props) {
  create(props);
};
ActionSheet.install = function (app2) {
  var name = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
  app2.component(name || ActionSheetVue.name, ActionSheetVue);
};
var _ActionSheet = ActionSheet;

export { _ActionSheet, _ActionSheet as default };
//# sourceMappingURL=index.mjs.map
