/**
 * tdesign v1.9.3
 * (c) 2025 TDesign Group
 * @license MIT
 */

import { _ as _defineProperty } from '../_chunks/dep-900db0e1.mjs';
import { defineComponent, computed, createVNode } from 'vue';
import props from './cell-group-props.mjs';
import config from '../config.mjs';
import { usePrefixClass } from '../hooks/useClass.mjs';
import { useTNodeJSX } from '../hooks/tnode.mjs';
import '../_chunks/dep-4915223e.mjs';
import '../config-provider/useConfig.mjs';
import 'lodash-es';
import '../config-provider/context.mjs';
import '../_common/js/global-config/mobile/default-config.mjs';
import '../_common/js/global-config/mobile/locale/zh_CN.mjs';
import '../_chunks/dep-bca0f578.mjs';
import '../_chunks/dep-6b2b02fd.mjs';
import '../_chunks/dep-c6f44a15.mjs';
import '../_chunks/dep-c984d53e.mjs';
import '../config-provider/type.mjs';
import '../hooks/render-tnode.mjs';
import '../_common/js/utils/general.mjs';

var prefix = config.prefix;
var _CellGroup = defineComponent({
  name: "".concat(prefix, "-cell-group"),
  props: props,
  setup: function setup(props2) {
    var renderTNodeJSX = useTNodeJSX();
    var cellGroupClass = usePrefixClass("cell-group");
    var contentClasses = computed(function () {
      return [cellGroupClass.value, "".concat(cellGroupClass.value, "--").concat(props2.theme), _defineProperty({}, "".concat(cellGroupClass.value, "--bordered"), props2.bordered)];
    });
    return function () {
      var title = renderTNodeJSX("title");
      return createVNode("div", null, [title ? createVNode("div", {
        "class": "".concat(cellGroupClass.value, "__title")
      }, [title]) : null, createVNode("div", {
        "class": contentClasses.value
      }, [renderTNodeJSX("default")])]);
    };
  }
});

export { _CellGroup as default };
//# sourceMappingURL=cell-group.mjs.map
