/**
 * tdesign v1.9.3
 * (c) 2025 TDesign Group
 * @license MIT
 */

import { defineComponent, createVNode, Fragment } from 'vue';
import config from '../config.mjs';
import props from './props.mjs';
import { provideConfig } from './useConfig.mjs';
import { useTNodeJSX } from '../hooks/tnode.mjs';
import '../_chunks/dep-900db0e1.mjs';
import '../_chunks/dep-4915223e.mjs';
import 'lodash-es';
import './context.mjs';
import '../_common/js/global-config/mobile/default-config.mjs';
import '../_common/js/global-config/mobile/locale/zh_CN.mjs';
import '../_chunks/dep-bca0f578.mjs';
import '../_chunks/dep-6b2b02fd.mjs';
import '../_chunks/dep-c6f44a15.mjs';
import '../_chunks/dep-c984d53e.mjs';
import './type.mjs';
import '../hooks/render-tnode.mjs';
import '../_common/js/utils/general.mjs';

var prefix = config.prefix;
var name = "".concat(prefix, "-config-provider");
var _ConfigProvider = defineComponent({
  name: name,
  props: props,
  setup: function setup(props2) {
    provideConfig(props2);
    var renderTNodeJSX = useTNodeJSX();
    return function () {
      return createVNode(Fragment, null, [renderTNodeJSX("default")]);
    };
  }
});

export { _ConfigProvider as default };
//# sourceMappingURL=config-provider.mjs.map
