/**
 * tdesign v1.9.3
 * (c) 2025 TDesign Group
 * @license MIT
 */

import { _ as _defineProperty } from '../_chunks/dep-900db0e1.mjs';
import { defineComponent, computed, createVNode } from 'vue';
import config from '../config.mjs';
import DividerProps from './props.mjs';
import { useContent } from '../hooks/tnode.mjs';
import { usePrefixClass } from '../hooks/useClass.mjs';
import '../_chunks/dep-4915223e.mjs';
import 'lodash-es';
import '../hooks/render-tnode.mjs';
import '../_common/js/utils/general.mjs';
import '../config-provider/useConfig.mjs';
import '../config-provider/context.mjs';
import '../_common/js/global-config/mobile/default-config.mjs';
import '../_common/js/global-config/mobile/locale/zh_CN.mjs';
import '../_chunks/dep-bca0f578.mjs';
import '../_chunks/dep-6b2b02fd.mjs';
import '../_chunks/dep-c6f44a15.mjs';
import '../_chunks/dep-c984d53e.mjs';
import '../config-provider/type.mjs';

var prefix = config.prefix;
var _Divider = defineComponent({
  name: "".concat(prefix, "-divider"),
  props: DividerProps,
  setup: function setup(props) {
    var renderTNodeContent = useContent();
    var dividerClass = usePrefixClass("divider");
    var dividerClasses = computed(function () {
      return ["".concat(dividerClass.value), "".concat(dividerClass.value, "--").concat(props.layout), "".concat(dividerClass.value, "--").concat(props.align), _defineProperty({}, "".concat(dividerClass.value, "--dashed"), props.dashed)];
    });
    return function () {
      var content = renderTNodeContent("default", "content");
      return createVNode("div", {
        "class": dividerClasses.value,
        "role": "separator"
      }, [createVNode("div", {
        "class": "".concat(dividerClass.value, "__content")
      }, [content])]);
    };
  }
});

export { _Divider as default };
//# sourceMappingURL=divider.mjs.map
