/**
 * tdesign v1.9.3
 * (c) 2025 TDesign Group
 * @license MIT
 */

import { _ as _toConsumableArray } from '../../_chunks/dep-fb4113ef.mjs';
import { defineComponent, createVNode } from 'vue';
import config from '../../config.mjs';
import { usePrefixClass } from '../../hooks/useClass.mjs';
import '../../_chunks/dep-a953013f.mjs';
import '../../config-provider/useConfig.mjs';
import '../../_chunks/dep-900db0e1.mjs';
import '../../_chunks/dep-4915223e.mjs';
import 'lodash-es';
import '../../config-provider/context.mjs';
import '../../_common/js/global-config/mobile/default-config.mjs';
import '../../_common/js/global-config/mobile/locale/zh_CN.mjs';
import '../../_chunks/dep-bca0f578.mjs';
import '../../_chunks/dep-6b2b02fd.mjs';
import '../../_chunks/dep-c6f44a15.mjs';
import '../../_chunks/dep-c984d53e.mjs';
import '../../config-provider/type.mjs';

var prefix = config.prefix;
var SpinnerIcon = defineComponent({
  name: "".concat(prefix, "-spinner"),
  props: {
    style: Object
  },
  setup: function setup(props) {
    var spinnerClass = usePrefixClass("loading__spinner");
    return function () {
      return createVNode("span", {
        "class": spinnerClass.value,
        "style": props.style
      }, [_toConsumableArray(new Array(12)).map(function (_, index) {
        return createVNode("i", {
          "class": ["".concat(spinnerClass.value, "--line"), "".concat(spinnerClass.value, "--line-").concat(index + 1)]
        }, null);
      })]);
    };
  }
});

export { SpinnerIcon as default };
//# sourceMappingURL=spinner.mjs.map
