/**
 * tdesign v1.9.3
 * (c) 2025 TDesign Group
 * @license MIT
 */

import { ref } from 'vue';
import { isBrowser } from '../shared/util.js';
import '@babel/runtime/helpers/slicedToArray';
import 'lodash-es';
import '../hooks/useClass.js';
import '../config-provider/useConfig.js';
import '@babel/runtime/helpers/defineProperty';
import '../config-provider/context.js';
import '../_common/js/global-config/mobile/default-config.js';
import '../_common/js/global-config/mobile/locale/zh_CN.js';
import '../_chunks/dep-f785f3d3.js';
import '@babel/runtime/helpers/typeof';
import '../_chunks/dep-0d44b254.js';
import 'dayjs';

var supportsPassive = ref(false);
if (!isBrowser) {
  try {
    var opts = {};
    Object.defineProperty(opts, "passive", {
      get: function get() {
        supportsPassive.value = true;
        return true;
      }
    });
    window.addEventListener("test-passive", null, opts);
  } catch (e) {}
}

export { supportsPassive };
//# sourceMappingURL=supportsPassive.js.map
