/**
 * tdesign v1.9.3
 * (c) 2025 TDesign Group
 * @license MIT
 */

import { defineComponent, createVNode, Fragment } from 'vue';
import config from '../config.js';
import props from './props.js';
import { provideConfig } from './useConfig.js';
import { useTNodeJSX } from '../hooks/tnode.js';
import '@babel/runtime/helpers/defineProperty';
import 'lodash-es';
import './context.js';
import '../_common/js/global-config/mobile/default-config.js';
import '../_common/js/global-config/mobile/locale/zh_CN.js';
import '../_chunks/dep-f785f3d3.js';
import '@babel/runtime/helpers/typeof';
import '../_chunks/dep-0d44b254.js';
import 'dayjs';
import '../hooks/render-tnode.js';
import '../_common/js/utils/general.js';

var prefix = config.prefix;
var name = "".concat(prefix, "-config-provider");
var _ConfigProvider = defineComponent({
  name: name,
  props: props,
  setup: function setup(props2) {
    provideConfig(props2);
    var renderTNodeJSX = useTNodeJSX();
    return function () {
      return createVNode(Fragment, null, [renderTNodeJSX("default")]);
    };
  }
});

export { _ConfigProvider as default };
//# sourceMappingURL=config-provider.js.map
